unit rmSwitchLed;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TBorderType = (btNone, btRaised, btLowered, btSingle);
  TLedPosition = (lpTopRight, lpTopLeft, lpBottomRight, lpBottomLeft);
  TrmSwitchLed = class(TGraphicControl)
  private
    { Dclarations prives }
    FBmpBuffer: TBitmap;
    FCaption: string;
    FCaptionOn: string;
    FUseCaptionOn: boolean;
    FShowLed: boolean;
    FLedPosition: TLedPosition;
    FLedHorzOffset,
    FLedVertOffset: integer;
    FLedHeight,
    FLedWidth: integer;
    FLedOnColor,
    FLedOffColor: TColor;
    FLedDisabledColor: TColor;
    FShowText: boolean;
    FTextFontName: string;
    FTextFontOnColor: TColor;
    FTextFontOffColor: TColor;
    FTextFontDisabledColor: TColor;
    FTextFontSize: integer;
    FTextHorzOffset: integer;
    FTextVertOffset: integer;
    FBGColor: TColor;
    FBorderColor: TColor;
    FButtonBorderColor: TColor;
    FSwitchOnColor: TColor;
    FSwitchOffColor: TColor;
    FSwitchDisabledColor: TColor;
    FBorder: TBorderType;
    FButtonBorder: TBorderType;
    FHorzMargin: integer;
    FVertMargin: integer;
    FSwitchOn: boolean;
    FSwitchOn3D: boolean;
    FAllowAllUp: boolean;
    FGroupIndex: integer;
    FOnChange: TNotifyEvent;
    procedure SetCaptionOn(value: string);
    procedure SetCaption(value: string);
    procedure SetUseCaptionOn(value: boolean);
    procedure SetShowLed(value: boolean);
    procedure SetLedPosition(value: TLedPosition);
    procedure SetLedHorzOffset(value: integer);
    procedure SetLedVertOffset(value: integer);
    procedure SetLedHeight(value: integer);
    procedure SetLedWidth(value: integer);
    procedure SetLedOnColor(value: TColor);
    procedure SetLedOffColor(value: TColor);
    procedure SetLedDisabledColor(value: TColor);
    procedure SetShowText(value: boolean);
    procedure SetTextFontName(value: string);
    procedure SetTextFontOnColor(value: TColor);
    procedure SetTextFontOffColor(value: TColor);
    procedure SetTextFontDisabledColor(value: TColor);
    procedure SetTextFontSize(value: integer);
    procedure SetTextHorzOffset(value: integer);
    procedure SetTextVertOffset(value: integer);
    procedure SetBGColor(value: TColor);
    procedure SetBorderColor(value: TColor);
    procedure SetButtonBorderColor(value: TColor);
    procedure SetSwitchOnColor(value: TColor);
    procedure SetSwitchOffColor(value: TColor);
    procedure SetSwitchDisabledColor(value: TColor);
    procedure SetBorder(value: TBorderType);
    procedure SetButtonBorder(value: TBorderType);
    procedure SetHorzMargin(value: integer);
    procedure SetVertMargin(value: integer);
    procedure SetSwitchOn(value: boolean);
    procedure SetSwitchOn3D(value: boolean);
    procedure SetAllowAllUp(value: boolean);
    procedure SetGroupIndex(value: integer);
    procedure SetAllSwitchLedComponents;
  protected
    { Dclarations protges }
    procedure Paint; override;
    procedure SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
    procedure UpdateBmpBuffer;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer); override;
  public
    constructor Create(anOwner:TComponent); override;
    destructor Destroy; override;
    procedure Free;
    { Dclarations publiques }
  published
    { Dclarations publies }
    property CaptionOn: string read FCaptionOn write SetCaptionOn;
    property Caption: string read FCaption write SetCaption;
    property UseCaptionOn: boolean read FUseCaptionOn write SetUseCaptionOn;
    property ShowLed: boolean read FShowLed write SetShowLed;
    property LedPosition: TLedPosition read FLedPosition write SetLedPosition;
    property LedHorzOffset: integer read FLedHorzOffset write SetLedHorzOffset;
    property LedVertOffset: integer read FLedVertOffset write SetLedVertOffset;
    property LedHeight: integer read FLedHeight write SetLedHeight;
    property LedWidth: integer read FLedWidth write SetLedWidth;
    property LedOnColor: TColor read FLedOnColor write SetLedOnColor;
    property LedOffColor: TColor read FLedOffColor write SetLedOffColor;
    property LedDisabledColor: TColor read FLedDisabledColor write SetLedDisabledColor;
    property ShowText: boolean read FShowText write SetShowText;
    property TextFontName: string read FTextFontName write SetTextFontName;
    property TextFontOnColor: TColor read FTextFontOnColor write SetTextFontOnColor;
    property TextFontOffColor: TColor read FTextFontOffColor write SetTextFontOffColor;
    property TextFontDisabledColor: TColor read FTextFontDisabledColor write SetTextFontDisabledColor;
    property TextFontSize: integer read FTextFontSize write SetTextFontSize;
    property TextHorzOffset: integer read FTextHorzOffset write SetTextHorzOffset;
    property TextVertOffset: integer read FTextVertOffset write SetTextVertOffset;
    property BGColor: TColor read FBGColor write SetBGColor;
    property BorderColor: TColor read FBorderColor write SetBorderColor;
    property ButtonBorderColor: TColor read FButtonBorderColor write SetButtonBorderColor;
    property SwitchOnColor: TColor read FSwitchOnColor write SetSwitchOnColor;
    property SwitchOffColor: TColor read FSwitchOffColor write SetSwitchOffColor;
    property SwitchDisabledColor: TColor read FSwitchDisabledColor write SetSwitchDisabledColor;
    property Border: TBorderType read FBorder write SetBorder;
    property ButtonBorder: TBorderType read FButtonBorder write SetButtonBorder;
    property HorzMargin: integer read FHorzMargin write SetHorzMargin;
    property VertMargin: integer read FVertMargin write SetVertMargin;
    property SwitchOn: boolean read FSwitchOn write SetSwitchOn;
    property SwitchOn3D: boolean read FSwitchOn3D write SetSwitchOn3D;
    property AllowAllUp: boolean read FAllowAllUp write SetAllowAllUp;
    property GroupIndex: integer read FGroupIndex write SetGroupIndex;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;

    { Standard properties and events}
    // property Align;
    property Enabled;
    property Height;
    property Width;
    property PopupMenu;
    property Hint;
    property ShowHint;
    property Tag;
    property Visible;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('OptoElec', [TrmSwitchLed]);
end;

constructor TrmSwitchLed.Create(anOwner:TComponent);
begin
  Inherited Create(anOwner);
  FBmpBuffer := TBitmap.Create;
  width := 89;
  height := 23;
  FBorder := btNone;
  FButtonBorder := btRaised;
  FCaption := 'Filter';
  FCaptionOn := 'Filter On';
  FUseCaptionOn := false;
  FBGColor := clBlack;
  FBorderColor := clBlack;
  FShowLed := true;
  FLedPosition := lpTopRight;
  FLedHorzOffset := 7;
  FLedVertOffset := 7;
  FLedHeight := 5;
  FLedWidth := 12;
  FLedOnColor := clLime;
  FLedOffColor := clGray;
  FLedDisabledColor := clSilver;
  FShowText := true;
  FTextFontName := 'Arial';
  FTextFontOnColor := clLime;
  FTextFontOffColor := clYellow;
  FTextFontDisabledColor := clSilver;
  FTextFontSize := 8;
  FTextHorzOffset := 8;
  FTextVertOffset := 0;
  FHorzMargin := 1;
  FVertMargin := 1;
  FSwitchOn := false;
  FSwitchOn3D := false;
  FSwitchOnColor := clMaroon;
  FSwitchOffColor := clMaroon;
  FSwitchDisabledColor := clGray;
  FAllowAllUp := true;
  FGroupIndex := 0;
end;

destructor TrmSwitchLed.Destroy;
begin
  If FBmpBuffer <> NIL then FBmpBuffer.free;
  Inherited Destroy;
end;

procedure TrmSwitchLed.Free;
begin
  FBmpBuffer.Free;
  Inherited Free;
end;

procedure TrmSwitchLed.SetBounds(aLeft, aTop, aWidth, aHeight: Integer);
begin
  Inherited ;
  If FBmpBuffer <> NIL then begin
    FBmpBuffer.Destroy;
    FBmpBuffer := TBitmap.Create;
    FBmpBuffer.Height := aHeight;
    FBmpBuffer.Width := aWidth;
  end;
end;

procedure TrmSwitchLed.Paint;
begin
  try
    UpdateBmpBuffer;
  except
  end;
  try
    Canvas.Draw(0, 0, FBmpBuffer);
  except
  end;
end;

procedure TrmSwitchLed.UpdateBmpBuffer;

  procedure GetButtonCoordinates(var X1, Y1, X2, Y2: integer;
              ActiveState: Boolean);
  var
    ButtonHeight, ButtonWidth: integer;
  begin
    ButtonHeight := height - (2 * FVertMargin);
    ButtonWidth := width - (2 * FHorzMargin);
    if ActiveState then begin
      X1 := width - FHorzMargin - ButtonWidth;
      Y1 := FVertMargin;
      X2 := width - FHorzMargin;
      Y2 := FVertMargin + ButtonHeight;
    end else begin
      X1 := FHorzMargin;
      Y1 := FVertMargin;
      X2 := FHorzMargin + ButtonWidth;
      Y2 := FVertMargin + ButtonHeight;
    end;
    if not FSwitchOn then begin
      X1 := X1 - 1;
      Y1 := Y1 - 1;
      X2 := X2 - 1;
      Y2 := Y2 - 1;
    end;
  end;

  procedure DrawBackGround;
  begin
    With FBmpBuffer.Canvas do begin
      if Border = btSingle then
        Pen.Color := FBorderColor
      else
        Pen.Color := FBGColor;
      Brush.Color := FBGColor;
      Rectangle(0, 0, width, height);
    end;
  end;

  procedure Draw3DBorder;
  begin
    With FBmpBuffer.Canvas do begin
      if (FBorder = btRaised) or (FBorder = btLowered) then begin
        if FBorder = btRaised then
          Pen.Color := clWhite
        else
          pen.color := clGray;
        moveTo(0, height - 1);
        lineTo(0, 0);
        lineTo(width - 1, 0);
        if FBorder = btRaised then
          Pen.Color := clGray
        else
          pen.color := clWhite;
        lineTo(width - 1, height - 1);
        lineTo(0, height - 1);
      end;
    end;
  end;

  procedure DrawButton;
  var
    X1, Y1, X2, Y2: integer;
    StateColor: TColor;
  begin
    GetButtonCoordinates(X1, Y1, X2, Y2, FSwitchOn);
    if FSwitchOn then
      StateColor := FSwitchOnColor
    else
      StateColor := FSwitchOffColor;

    With FBmpBuffer.Canvas do begin
      if ButtonBorder = btSingle then
        Pen.Color := FButtonBorderColor
      else
        Pen.Color := StateColor;
      if Enabled then
        Brush.Color := StateColor
      else
        Brush.Color := SwitchDisabledColor;
      Rectangle(X1, Y1, X2, Y2);
    end;
  end;

  procedure Draw3DButtonBorder;
  var
    X1, Y1, X2, Y2: integer;
  begin
    With FBmpBuffer.Canvas do begin
      if (FButtonBorder = btRaised) or
         (FButtonBorder = btLowered) then begin
        GetButtonCoordinates(X1, Y1, X2, Y2, FSwitchOn);
        if not FSwitchOn then
          Pen.Color := clWhite
        else if FSwitchOn then
          pen.color := clGray;
        moveTo(X1, Y2 - 1);
        lineTo(X1, Y1);
        lineTo(X2 - 1, Y1);
        if SwitchOn3D then begin
          if not FSwitchOn then
            Pen.Color := clGray
          else if FSwitchOn then
            pen.color := clWhite;
        end else begin
          if not FSwitchOn then
            Pen.Color := FSwitchOffColor
          else if FSwitchOn then
            pen.color := FSwitchOnColor;
        end;
        lineTo(X2 - 1, Y2 - 1);
        lineTo(X1, Y2 - 1);
      end;
    end;
  end;

  procedure GetLedPosition(var X1, Y1, X2, Y2: integer);
  begin
    if FLedPosition = lpTopRight then begin
      X1 := width - FLedWidth - FLedHorzOffset;
      Y1 := FLedVertOffset;
      X2 := width - FLedHorzOffset;
      Y2 := FLedVertOffset + FLedHeight;
    end else if FLedPosition = lpTopLeft then begin
      X1 := FLedHorzOffset;
      Y1 := FLedVertOffset;
      X2 := FLedHorzOffset + FLedWidth;
      Y2 := FLedVertOffset + FLedHeight;
    end else if FLedPosition = lpBottomRight then begin
      X1 := width - FLedWidth - FLedHorzOffset;
      Y1 := height - FLedVertOffset - FLedHeight;
      X2 := width - FLedHorzOffset;
      Y2 := height - FLedVertOffset;
    end else if FLedPosition = lpBottomLeft then begin
      X1 := FLedHorzOffset;
      Y1 := height - FLedVertOffset - FLedHeight;
      X2 := FLedHorzOffset + FLedWidth;
      Y2 := height - FLedVertOffset;
    end;
    if not FSwitchOn then begin
      X1 := X1 - 1;
      Y1 := Y1 - 1;
      X2 := X2 - 1;
      Y2 := Y2 - 1;
    end;
  end;

  procedure DrawLed;
  var
    X1, Y1, X2, Y2: integer;
  begin
    GetLedPosition(X1, Y1, X2, Y2);
    With FBmpBuffer.Canvas do begin
      if not Enabled then begin
        Pen.Color := FLedDisabledColor;
        Brush.Color := FLedDisabledColor;
      end else begin
        if FSwitchOn then begin
          Pen.Color := FLedOnColor;
          Brush.Color := FLedOnColor;
        end else begin
          Pen.Color := FLedOffColor;
          Brush.Color := FLedOffColor;
        end;
      end;
      Rectangle(X1, Y1, X2, Y2);
      // 3D effect
      pen.color := clGray;
      MoveTo(X1, Y2);
      LineTo(X1,Y1);
      LineTo(X2, Y1);
      pen.color := clWhite;
      LineTo(X2, Y2);
      LineTo(X1, Y2);
    end;
  end;

  procedure GetTextPosition(var X, Y: integer);
  begin
    if FLedPosition = lpTopRight then begin
      X := FTextHorzOffset;
      Y := trunc((height - FBmpBuffer.canvas.TextHeight('WXYZ')) / 2) + FTextVertOffset;
    end else if FLedPosition = lpTopLeft then begin
      X := width - FTextHorzOffset - FBmpBuffer.canvas.TextWidth('WXYZ');
      Y := trunc((height - FBmpBuffer.canvas.TextHeight('WXYZ')) / 2) + FTextVertOffset;
    end else if FLedPosition = lpBottomRight then begin
      X := FTextHorzOffset;
      Y := trunc((height - FBmpBuffer.canvas.TextHeight('WXYZ')) / 2) + FTextVertOffset;
    end else if FLedPosition = lpBottomLeft then begin
      X := width - FTextHorzOffset - FBmpBuffer.canvas.TextWidth('WXYZ');
      Y := trunc((height - FBmpBuffer.canvas.TextHeight('WXYZ')) / 2) + FTextVertOffset;
    end;
    if not FSwitchOn then begin
      X := X - 1;
      Y := Y - 1;
    end;
  end;

  procedure DrawText;
  var
    X, Y: integer;
  begin
    With FBmpBuffer.Canvas do begin
      if not Enabled then begin
        Pen.Color := FSwitchDisabledColor;
        Brush.Color := FSwitchDisabledColor;
        font.Color := FTextFontDisabledColor;
      end else begin
        if FSwitchOn then begin
          Pen.Color := FSwitchOnColor;
          Brush.Color := FSwitchOnColor;
          font.Color := FTextFontOnColor;
        end else begin
          Pen.Color := FSwitchOffColor;
          Brush.Color := FSwitchOffColor;
          font.Color := FTextFontOffColor;
        end;
      end;
      font.name := FTextFontName;
      font.size := FTextFontSize;
      GetTextPosition(X, Y);
      if (FUseCaptionOn and FSwitchOn) then
        textOut(x, Y, FCaptionOn)
      else
        textOut(x, Y, FCaption);
    end;
  end;

begin
  DrawBackGround;
  Draw3DBorder;
  DrawButton;
  Draw3DButtonBorder;
  if FShowLed then DrawLed;
  if FShowText then DrawText;
end;

procedure TrmSwitchLed.SetCaptionOn(value: string);
begin
  if value <> FCaptionOn then
  begin
    FCaptionOn := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetUseCaptionOn(value: boolean);
begin
  if value <> FUseCaptionOn then
  begin
    FUseCaptionOn := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetCaption(value: string);
begin
  if value <> FCaption then
  begin
    FCaption := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetShowLed(value: boolean);
begin
  if value <> FShowLed then
  begin
    FShowLed := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedPosition(value: TLedPosition);
begin
  if value <> FLedPosition then
  begin
    FLedPosition := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedHorzOffset(value: integer);
begin
  if value <> FLedHorzOffset then
  begin
    FLedHorzOffset := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedVertOffset(value: integer);
begin
  if value <> FLedVertOffset then
  begin
    FLedVertOffset := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedHeight(value: integer);
begin
  if value <> FLedHeight then
  begin
    FLedHeight := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedWidth(value: integer);
begin
  if value <> FLedWidth then
  begin
    FLedWidth := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedOnColor(value: TColor);
begin
  if value <> FLedOnColor then
  begin
    FLedOnColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedOffColor(value: TColor);
begin
  if value <> FLedOffColor then
  begin
    FLedOffColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetLedDisabledColor(value: TColor);
begin
  if value <> FLedDisabledColor then
  begin
    FLedDisabledColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetShowText(value: boolean);
begin
  if value <> FShowText then
  begin
    FShowText := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextFontName(value: string);
begin
  if value <> FTextFontName then
  begin
    FTextFontName := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextFontOnColor(value: TColor);
begin
  if value <> FTextFontOnColor then
  begin
    FTextFontOnColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextFontOffColor(value: TColor);
begin
  if value <> FTextFontOffColor then
  begin
    FTextFontOffColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextFontDisabledColor(value: TColor);
begin
  if value <> FTextFontDisabledColor then
  begin
    FTextFontDisabledColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextFontSize(value: integer);
begin
  if value <> FTextFontSize then
  begin
    FTextFontSize := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextHorzOffset(value: integer);
begin
  if value <> FTextHorzOffset then
  begin
    FTextHorzOffset := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetTextVertOffset(value: integer);
begin
  if value <> FTextVertOffset then
  begin
    FTextVertOffset := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetBGColor(value: TColor);
begin
  if value <> FBGColor then
  begin
    FBGColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetBorderColor(value: TColor);
begin
  if value <> FBorderColor then
  begin
    FBorderColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetButtonBorderColor(value: TColor);
begin
  if value <> FButtonBorderColor then
  begin
    FButtonBorderColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetSwitchOnColor(value: TColor);
begin
  if value <> FSwitchOnColor then
  begin
    FSwitchOnColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetSwitchOffColor(value: TColor);
begin
  if value <> FSwitchOffColor then
  begin
    FSwitchOffColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetSwitchDisabledColor(value: TColor);
begin
  if value <> FSwitchDisabledColor then
  begin
    FSwitchDisabledColor := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetBorder(value: TBorderType);
begin
  if value <> FBorder then
  begin
    FBorder := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetButtonBorder(value: TBorderType);
begin
  if value <> FButtonBorder then
  begin
    FButtonBorder := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetHorzMargin(value: integer);
begin
  if value <> FHorzMargin then
  begin
    FHorzMargin := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetVertMargin(value: integer);
begin
  if value <> FVertMargin then
  begin
    FVertMargin := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetSwitchOn(value: boolean);
begin
  if value <> FSwitchOn then
  begin
    FSwitchOn := value;
    if FGroupIndex <> 0 then
      SetAllSwitchLedComponents;
    Paint;
    if assigned(FOnChange) then
      FOnChange(self);
  end;
end;

procedure TrmSwitchLed.SetAllowAllUp(value: boolean);
begin
  if value <> FAllowAllUp then
  begin
    // FAllowAllUp := value;
    FAllowAllUp := true;
    if FGroupIndex <> 0 then
      SetAllSwitchLedComponents;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetAllSwitchLedComponents;
var
  i, iGrpIdx, tmpGroupIndex: integer;
  bDown, tmpAllowAllUp: boolean;
  tmpDown, OneOrMoreDown: boolean;
begin
  if FGroupIndex = 0 then exit;
  tmpGroupIndex := FGroupIndex;
  tmpAllowAllUp := FAllowAllUp;
  tmpDown := FSwitchOn;
  OneOrMoreDown := false;
  // showmessage(inttostr(parent.ComponentCount));
  for i := 0 to pred(parent.ComponentCount) do begin
    if not(parent.components[i] is TrmSwitchLed) then continue;
    iGrpIdx := (parent.components[i] as TrmSwitchLed).GroupIndex;
    // bAllowAllUp := (parent.components[i] as TrmSwitchLed).AllowAllUp;
    bDown := (parent.components[i] as TrmSwitchLed).switchOn;
    if iGrpIdx = tmpGroupIndex then begin
      (parent.components[i] as TrmSwitchLed).AllowAllUp := tmpAllowAllUp;
      OneOrMoreDown := OneOrMoreDown or bDown;
      if tmpDown and bDown then
        (parent.components[i] as TrmSwitchLed).switchOn := false;
    end;
  end;
  {
  if (not tmpAllowAllUp) and (not OneOrMoreDown) then
    FSwitchOn := true
  else if (tmpAllowAllUp) and (not OneOrMoreDown) then
    FSwitchOn := false
  else
  }
  FSwitchOn := tmpDown;
end;

procedure TrmSwitchLed.SetGroupIndex(value: integer);
begin
  if value <> FGroupIndex then
  begin
    FGroupIndex := value;
    if FGroupIndex <> 0 then
      SetAllSwitchLedComponents;
    Paint;
  end;
end;

procedure TrmSwitchLed.SetSwitchOn3D(value: boolean);
begin
  if value <> FSwitchOn3D then
  begin
    FSwitchOn3D := value;
    Paint;
  end;
end;

procedure TrmSwitchLed.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
  if not enabled then exit;
  SetSwitchOn(not FSwitchOn);
  paint;
end;


end.
